#include <math.h>
#define EQUAL(a, b) (fabs((a) - (b)) < 0.0000001)


void aggregate_monthly_output(const double *var_local, const int *ncells, const int *nmonths, const int *nyears, const double *NAvalue,
                  double *var_sum, int *return_months)
{
	int c, m, y, nmonths_cell;
	double mean_value;

	for (y = 0; y < *nyears; y++) {
		for (c = 0; c < *ncells; c++) {
			mean_value=0;
			nmonths_cell = *nmonths;
			for (m = 0; m < *nmonths; m++) {
				if (!EQUAL(var_local[y * *nmonths * *ncells + m * *ncells + c], *NAvalue))
					mean_value += var_local[y * *nmonths * *ncells + m * *ncells + c];
				else 
					nmonths_cell--;
			}
			if (nmonths_cell > 0)
				var_sum[y * *ncells + c] = mean_value;
			else
				var_sum[y * *ncells + c] = *NAvalue;
			return_months[y * *ncells + c] = nmonths_cell;
		}
	}
}

/*
to compile locally
R CMD SHLIB --preclean --static aggregate_monthly_output.c -lm

*/
