#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <math.h>

#define BSQ
#define DATA_TYPE float 
#define DATA_TYPE_OUT float 
#define STARTBAND 0 
#define EPSILON 0.00000001
#define check_ptr(ptr) if((ptr)==NULL) failu("Error allocating memory\n")
#define check_file(file) if((file)==NULL) failu("Error opening file\n")

void failu(const char* str){
  fprintf(stderr, "%s\n", str);
  exit(-1);
}

void usage(char* progname){
  fprintf(stderr, "Use:\n%s ifile1 ofile npixel lower upper [startband1(default:0) endband1(default:all)]\nsets values < lower to lower, > upper to upper\n", progname);
  exit(-1);
}

int main(int argc, char* argv[]){
  int i,p,y,b, npixel,nbands,nbands1,startband1, endband1;
  long int count;
  DATA_TYPE *rbuf1; 
  DATA_TYPE_OUT *wbuf,lout,uout;
  char* ifilename1, *ofilename;
  double lower,upper;
  FILE* ifile1, *ofile;
  struct stat filestat;

  /* Parse command line */
  if (argc < 6) usage(argv[0]);
  ifilename1 = argv[1];
  ofilename = argv[2];
  npixel = atoi(argv[3]);
  lower = atof(argv[4]);
  upper = atof(argv[5]);
  /* Open files */
  ifile1 = fopen64(ifilename1, "rb");
  check_file(ifile1);
  ofile = fopen64(ofilename, "wb");
  check_file(ofile);
  
  /* file statistics */
  fstat(fileno(ifile1),&filestat);
  nbands1=filestat.st_size/npixel/sizeof(DATA_TYPE);
  startband1=STARTBAND;
  endband1=nbands1-1;
  
  if (argc == 8){
    startband1 = atoi(argv[4]);
    endband1 = atoi(argv[5]);
  }
  printf("%d %d\n",startband1,endband1);
  nbands=endband1-startband1+1;
  /* round if necessary)*/
  lout=(DATA_TYPE_OUT)(lower+(lower<0?-0.5:0.5))-(DATA_TYPE_OUT)(lower<0?-0.5:0.5);
  uout=(DATA_TYPE_OUT)(upper+(upper<0?-0.5:0.5))-(DATA_TYPE_OUT)(upper<0?-0.5:0.5);
#ifdef BSQ
  /*memory allocation*/
  rbuf1=malloc(npixel*sizeof(DATA_TYPE));
  check_ptr(rbuf1);
  wbuf = malloc(npixel*sizeof(DATA_TYPE_OUT));
  check_ptr(wbuf);
  
  count=0;
  for(b=0; b<nbands; ++b){
    fseeko64(ifile1,sizeof(DATA_TYPE)*npixel*(startband1+b),SEEK_SET);
    if(fread(rbuf1, sizeof(DATA_TYPE),npixel,ifile1)!=npixel){
      fprintf(stderr,"error reading from file1\n");
      exit(-1);
    };
    for(p=0; p<npixel;++p)
        if (rbuf1[p]<lower){
            wbuf[p]=lout;
            ++count;
        }
	else if (rbuf1[p]>upper){
	    wbuf[p]=uout;
            ++count;
	}
        else
            wbuf[p]=(DATA_TYPE_OUT)(rbuf1[p]+(rbuf1[p]<0?-0.5:0.5))-(DATA_TYPE_OUT)(rbuf1[p]<0?-0.5:0.5);
    fwrite(wbuf,sizeof(DATA_TYPE_OUT),npixel,ofile);
  }
  printf("%d values have been corrected\n",count);
#endif
  free(rbuf1);
  free(wbuf);
  fclose(ifile1);
  fclose(ofile);
  return 0;
}
