#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <math.h>

#define BSQ
#define DATA_TYPE float
#define DATA_TYPE_OUT float
#define STARTBAND 0 
#define NAVALUE -9999
#define ROUND(x) ((DATA_TYPE_OUT)((x)+((x)<0?-0.5:0.5))-(DATA_TYPE_OUT)((x)<0?-0.5:0.5))
#define check_file(file) if((file)==NULL) failu("Error opening file\n")
#define check_ptr(ptr) if((ptr)==NULL) failu("Error allocating memory\n")
#define GROWTHRATE 2
#define MAXGROWTH 3
#define ASYMPT1 0
#define ASYMPT2 1

void usage(char* progname){
  fprintf(stderr, "Use:\n%s ifile ofile npixel [maxgrowth growthrate lower_asymptote upper_asymptote startband1(default:0) endband1(default:all)]\nCalculates logistic function (ifile)\nDefault Values: growthrate: %.1lf maximum growth: %.1lf Asymtotes:%.1lf %.1lf\n", progname,(double)GROWTHRATE,(double)MAXGROWTH,(double)ASYMPT1,(double)ASYMPT2);
  exit(-1);
}
void failu(const char* str){
  fprintf(stderr, "%s\n", str);
  exit(-1);
}

int main(int argc, char* argv[]){
  int i,p,y,b, npixel,nbands,nbands1,startband1, endband1;
  DATA_TYPE *rbuf1; 
  DATA_TYPE_OUT *wbuf;
  char* ifilename1, *ofilename;
  FILE* ifile1, *ofile;
  double g=GROWTHRATE,m=MAXGROWTH,a1=ASYMPT1,a2=ASYMPT2;
  struct stat filestat;
   
  /* Parse command line */
  if (argc < 4) usage(argv[0]);
  ifilename1 = argv[1];
  ofilename = argv[2];
  npixel = atoi(argv[3]);
  
  /* Open files */
  ifile1 = fopen64(ifilename1, "rb");
  check_file(ifile1);
  ofile = fopen64(ofilename, "wb");
  check_file(ofile);
  if (argc > 4)
      m=atof(argv[4]);
  if(argc > 5)
      g=atof(argv[5]);
  if (argc > 6)
      a1=atof(argv[6]);
  if (argc > 7)
      a2=atof(argv[7]);
  /* file statistics */
  fstat(fileno(ifile1),&filestat);
  nbands1=filestat.st_size/npixel/sizeof(DATA_TYPE);
  startband1=STARTBAND;
  endband1=nbands1-1;
  if (argc > 8){
    startband1 = atoi(argv[8]);
    endband1 = atoi(argv[9]);
  }
  //printf("%d %d\n",startband1,endband1);
  nbands=endband1-startband1+1;
  
#ifdef BSQ
  /*memory allocation*/
  rbuf1=malloc(npixel*sizeof(DATA_TYPE));
  check_ptr(rbuf1);
  wbuf = malloc(nbands*npixel*sizeof(DATA_TYPE_OUT));
  check_ptr(wbuf);
  fseeko64(ifile1,sizeof(DATA_TYPE)*npixel*(startband1),SEEK_SET);
  for(b=0; b<nbands; ++b){
    if(fread(rbuf1, sizeof(DATA_TYPE),npixel,ifile1)!=npixel){
      fprintf(stderr,"error reading from file1\n");
      exit(-1);
    };
    for(p=0; p<npixel;++p)
       wbuf[b*npixel+p]=ROUND(a1+(a2-a1)/(1+exp(-g*(rbuf1[p]-m))));
  }
  fwrite(wbuf,sizeof(DATA_TYPE_OUT),nbands*npixel,ofile);
#endif
  free(rbuf1);
  free(wbuf);
  fclose(ifile1);
  fclose(ofile);
  return 0;
}
