#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include "utilfunc.h"
#define BSQ
#define DATA_TYPE float
#define DATA_TYPE_OUT short
#define STARTBAND 0 

void usage(char* progname){
  fprintf(stderr, "Use:\n%s ifile ofile factor npixel [startband1(default:0) endband1(default:all)]\nCalculates ifile*factor\n", progname);
  exit(-1);
}

int main(int argc, char* argv[]){
  int i,p,y,b, npixel,nbands,nbands1,startband1, endband1;
  DATA_TYPE *rbuf1; 
  DATA_TYPE_OUT *wbuf;
  char* ifilename1, *ofilename;
  FILE* ifile1, *ofile;
  double factor;
  struct stat filestat;

  /* Parse command line */
  if (argc < 5) usage(argv[0]);
  ifilename1 = argv[1];
  ofilename = argv[2];
  factor = atof(argv[3]);
  npixel = atoi(argv[4]);
  
  /* Open files */
  ifile1 = fopen64(ifilename1, "rb");
  check_file(ifile1);
  ofile = fopen64(ofilename, "wb");
  check_file(ofile);
  
  /* file statistics */
  fstat(fileno(ifile1),&filestat);
  nbands1=filestat.st_size/npixel/sizeof(DATA_TYPE);
  startband1=STARTBAND;
  endband1=nbands1-1;
  
  if (argc == 7){
    startband1 = atoi(argv[5]);
    endband1 = atoi(argv[6]);
  }
  printf("%d %d\n",startband1,endband1);
  nbands=endband1-startband1+1;
  
#ifdef BSQ
  /*memory allocation*/
  rbuf1=malloc(npixel*sizeof(DATA_TYPE));
  check_ptr(rbuf1);
  wbuf = malloc(nbands*npixel*sizeof(DATA_TYPE_OUT));
  check_ptr(wbuf);
  fseeko64(ifile1,sizeof(DATA_TYPE)*npixel*(startband1),SEEK_SET);
  for(b=0; b<nbands; ++b){
    if(fread(rbuf1, sizeof(DATA_TYPE),npixel,ifile1)!=npixel){
      fprintf(stderr,"error reading from file1\n");
      exit(-1);
    };
    for(p=0; p<npixel;++p)
       wbuf[b*npixel+p]=(DATA_TYPE_OUT)(rbuf1[p]*factor+(rbuf1[p]*factor<0?-0.5:0.5))-(DATA_TYPE_OUT)(rbuf1[p]*factor<0?-0.5:0.5);   
  }
  fwrite(wbuf,sizeof(DATA_TYPE_OUT),nbands*npixel,ofile);
#endif
  free(rbuf1);
  free(wbuf);
  fclose(ifile1);
  fclose(ofile);
  return 0;
}
