#include <stdio.h>
#include <stdlib.h>
#define BSQ
#define DATA_TYPE float

#define check_ptr(ptr) if((ptr)==NULL) failu("Error allocating memory\n")
#define check_file(file) if((file)==NULL) failu("Error opening file\n")

void failu(const char* str){
  fprintf(stderr, "%s\n", str);
  exit(-1);
}

void usage(char* progname){
  fprintf(stderr, "Use:\n%s ifile ofile npixel nbands startband(0...nbands-1) endband(0...nbands-1)\n", progname);
  exit(-1);
}

int main(int argc, char* argv[]){
  long int i,p,b, npixel,nbands,startband,endband,subbands;
  DATA_TYPE *rbuf, *wbuf;
  char* ifilename, *ofilename;
  FILE* ifile, *ofile;

  /* Parse command line */
  if (argc < 7) usage(argv[0]);
  ifilename = argv[1];
  ofilename = argv[2];
  npixel = atoi(argv[3]);
  nbands = atoi(argv[4]);
  startband = atoi(argv[5]);
  endband = atoi(argv[6]);

  /* some checks */
  if (endband < startband
      || startband < 0
      || endband > nbands-1){
    fprintf(stderr, "Please make sure that 0<=startband<=endband<=nbands-1\nExit.\n");
    exit(-1);
  }
  subbands=endband-startband+1;

  /* Open files */
  ifile = fopen64(ifilename, "rb");
  check_file(ifile);
  ofile = fopen64(ofilename, "wb");
  check_file(ofile);

#ifdef BSQ
  /*memory allocation*/
  rbuf=(DATA_TYPE*) malloc(sizeof(DATA_TYPE)*npixel*nbands);
  check_ptr(rbuf);
  wbuf=(DATA_TYPE*) malloc(sizeof(DATA_TYPE)*npixel*subbands);
  check_ptr(wbuf);
  while(fread(rbuf,sizeof(DATA_TYPE), npixel*nbands, ifile)){
    for(i=startband,b=0; i<=endband; ++i,b++)
      for(p=0; p<npixel; ++p)
	wbuf[b*npixel+p]=rbuf[i*npixel+p];
    fwrite(wbuf, sizeof(DATA_TYPE), npixel*subbands, ofile);
  }

#endif
  free(rbuf);
  free(wbuf);
  fclose(ifile);
  fclose(ofile);
  return 0;
}
